'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ObjectDescription = require('../object/ObjectDescription');

var _ObjectDescription2 = _interopRequireDefault(_ObjectDescription);

var _ObjectPreview = require('../object/ObjectPreview');

var _ObjectPreview2 = _interopRequireDefault(_ObjectPreview);

var _objectStyles = require('../object/objectStyles');

var _objectStyles2 = _interopRequireDefault(_objectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Styles


var styles = {
  base: {
    fontFamily: 'Menlo, monospace',
    fontSize: '11px',
    lineHeight: '14px',
    cursor: 'default'
  },
  propertyNodesContainer: {
    paddingLeft: '12px'
  },
  unselectable: {
    WebkitTouchCallout: 'none',
    WebkitUserSelect: 'none',
    KhtmlUserSelect: 'none',
    MozUserSelect: 'none',
    msUserSelect: 'none',
    OUserSelect: 'none',
    userSelect: 'none'
  },
  expandControl: {
    color: '#6e6e6e',
    fontSize: '10px',
    marginRight: '3px',
    whiteSpace: 'pre'
  },
  property: {
    paddingTop: '2px'
  }
};

var DEFAULT_ROOT_PATH = 'root';
/**
 * Convert wild card paths to concrete paths
 * @param  {array} initialExpandedPaths  wild card paths
 * @param  {object} data                 data object
 * @param  {string} rootName             optional root name (if not specified will use DEFAULT_ROOT_PATH)
 * @return {array}                       concrete paths
 */
var pathsFromWildcardPaths = function pathsFromWildcardPaths(wildcardPaths, data) {
  var rootName = arguments.length <= 2 || arguments[2] === undefined ? DEFAULT_ROOT_PATH : arguments[2];

  var paths = [];
  if (wildcardPaths === undefined) {
    return paths;
  }
  wildcardPaths.map(function (expandedPath) {
    if (typeof expandedPath === 'string') {
      (function () {
        // wildcard names
        // recursively populate paths with wildcard paths

        var populatePaths = function populatePaths(curObject, curPath, i) {
          var WILDCARD = "*";
          if (i === names.length) {
            paths.push(curPath);
            return;
          }
          var name = names[i];
          if (i === 0) {
            if (name === rootName /*|| name === DEFAULT_ROOT_PATH*/ || name === WILDCARD) {
              populatePaths(curObject, 'root', i + 1);
            }
          } else {
            if (name === WILDCARD) {
              for (var propertyName in curObject) {
                if (curObject.hasOwnProperty(propertyName)) {
                  var propertyValue = curObject[propertyName];
                  if (ObjectInspector.isExpandable(propertyValue)) {
                    populatePaths(propertyValue, curPath + '.' + propertyName, i + 1);
                  } else {
                    continue;
                  }
                }
              }
            } else {
              var propertyValue = curObject[name];
              if (ObjectInspector.isExpandable(propertyValue)) {
                populatePaths(propertyValue, curPath + '.' + name, i + 1);
              }
            }
          }
        };

        var names = expandedPath.split('.');
        populatePaths(data, '', 0);
      })();
    }
  });
  return paths;
};

var ObjectInspector = function (_Component) {
  _inherits(ObjectInspector, _Component);

  _createClass(ObjectInspector, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // expanded paths need to be recalculated on new data arrival
      var paths = pathsFromWildcardPaths(nextProps.initialExpandedPaths, nextProps.data, nextProps.name);

      this.setState({
        expandedPaths: paths.reduce(function (obj, path) {
          obj[path] = true;return obj;
        }, {})
      });
    } // path is dot separated property names to reach the current node

  }]);

  function ObjectInspector(props) {
    _classCallCheck(this, ObjectInspector);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectInspector).call(this, props));

    if (props.depth === 0) {
      // root node

      var paths = pathsFromWildcardPaths(props.initialExpandedPaths, props.data, props.name);
      _this.state = {
        // expand every path
        expandedPaths: paths.reduce(function (obj, path) {
          obj[path] = true;return obj;
        }, {})
      };
    }
    return _this;
  }

  _createClass(ObjectInspector, [{
    key: 'getExpanded',
    value: function getExpanded(path) {
      var expandedPaths = this.state.expandedPaths;
      if (expandedPaths !== undefined && typeof expandedPaths[path] !== 'undefined') {
        return expandedPaths[path];
      }
      return false;
    }
  }, {
    key: 'setExpanded',
    value: function setExpanded(path, expanded) {
      var expandedPaths = this.state.expandedPaths;
      expandedPaths[path] = expanded;
      this.setState({ expandedPaths: expandedPaths });
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      // console.log(this.props.data);
      if (ObjectInspector.isExpandable(this.props.data)) {
        if (this.props.depth > 0) {
          this.props.setExpanded(this.props.path, !this.props.getExpanded(this.props.path));
        } else {
          this.setExpanded(this.props.path, !this.getExpanded(this.props.path));
        }
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (typeof _react2.default.initializeTouchEvents === 'function') {
        _react2.default.initializeTouchEvents(true);
      }
    }
  }, {
    key: 'render',
    value: function render() {

      var data = this.props.data;
      var name = this.props.name;

      var setExpanded = this.props.depth === 0 ? this.setExpanded.bind(this) : this.props.setExpanded;
      var getExpanded = this.props.depth === 0 ? this.getExpanded.bind(this) : this.props.getExpanded;
      var expanded = getExpanded(this.props.path);

      var expandGlyph = ObjectInspector.isExpandable(data) ? expanded ? '▼' : '▶' : this.props.depth === 0 ? '' // unnamed root node
      : ' ';

      var propertyNodesContainer = undefined;
      if (expanded) {
        var propertyNodes = [];

        for (var propertyName in data) {
          var propertyValue = data[propertyName];
          if (data.hasOwnProperty(propertyName)) {
            propertyNodes.push(_react2.default.createElement(ObjectInspector, { getExpanded: getExpanded,
              setExpanded: setExpanded,
              path: this.props.path + '.' + propertyName // TODO: escape '.' in propertyName
              , depth: this.props.depth + 1,
              key: propertyName,
              name: propertyName,
              data: propertyValue }));
          }
        }
        propertyNodesContainer = _react2.default.createElement(
          'div',
          { style: styles.propertyNodesContainer },
          propertyNodes
        );
      }

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        _react2.default.createElement(
          'span',
          { style: styles.property, onClick: this.handleClick.bind(this) },
          _react2.default.createElement(
            'span',
            { style: _extends({}, styles.expandControl, styles.unselectable) },
            expandGlyph
          ),
          function () {
            if (typeof name !== 'undefined') {
              return _react2.default.createElement(
                'span',
                null,
                _react2.default.createElement(
                  'span',
                  { style: _objectStyles2.default.name },
                  name
                ),
                _react2.default.createElement(
                  'span',
                  null,
                  ': '
                ),
                _react2.default.createElement(_ObjectDescription2.default, { object: data })
              );
            } else {
              return _react2.default.createElement(_ObjectPreview2.default, { object: data });
            }
          }()
        ),
        propertyNodesContainer
      );
    }
  }], [{
    key: 'isExpandable',
    value: function isExpandable(data) {
      return (typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object' && data !== null && Object.keys(data).length > 0;
    }
  }]);

  return ObjectInspector;
}(_react.Component);

ObjectInspector.defaultProps = {
  name: void 0,
  data: undefined,
  initialExpandedPaths: undefined,
  depth: 0,
  path: DEFAULT_ROOT_PATH
};
exports.default = ObjectInspector;