'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objectStyles = require('./objectStyles');

var _objectStyles2 = _interopRequireDefault(_objectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Styles


/**
 * A short description of the object
 */

var ObjectDescription = function (_Component) {
  _inherits(ObjectDescription, _Component);

  function ObjectDescription() {
    _classCallCheck(this, ObjectDescription);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectDescription).apply(this, arguments));
  }

  _createClass(ObjectDescription, [{
    key: 'render',
    value: function render() {
      var object = this.props.object;
      switch (typeof object === 'undefined' ? 'undefined' : _typeof(object)) {
        case 'number':
          return _react2.default.createElement(
            'span',
            { style: _objectStyles2.default.value.number },
            object
          );
        case 'string':
          return _react2.default.createElement(
            'span',
            { style: _objectStyles2.default.value.string },
            '"',
            object,
            '"'
          );
        case 'boolean':
          return _react2.default.createElement(
            'span',
            { style: _objectStyles2.default.value.boolean },
            String(object)
          );
        case 'undefined':
          return _react2.default.createElement(
            'span',
            { style: _objectStyles2.default.value.undefined },
            'undefined'
          );
        case 'object':
          if (object === null) {
            return _react2.default.createElement(
              'span',
              { style: _objectStyles2.default.value.null },
              'null'
            );
          }
          if (object instanceof Date) {
            return _react2.default.createElement(
              'span',
              null,
              object.toString()
            );
          }
          if (Array.isArray(object)) {
            return _react2.default.createElement(
              'span',
              null,
              'Array[' + object.length + ']'
            );
          }
          return _react2.default.createElement(
            'span',
            null,
            'Object'
          );
        case 'function':
          return _react2.default.createElement(
            'span',
            null,
            _react2.default.createElement(
              'span',
              { style: _objectStyles2.default.value.function.keyword },
              'function'
            ),
            _react2.default.createElement(
              'span',
              { style: _objectStyles2.default.value.function.name },
              ' ',
              object.name,
              '()'
            )
          );
        case 'symbol':
          return _react2.default.createElement(
            'span',
            { style: _objectStyles2.default.value.symbol },
            'Symbol()'
          );
        default:
          return _react2.default.createElement('span', null);
      }
    }
  }]);

  return ObjectDescription;
}(_react.Component);

exports.default = ObjectDescription;


ObjectDescription.propTypes = {
  object: _react2.default.PropTypes.any
};